## x2gobroker 0.0.4.0

=== Makefile ===
#!/usr/bin/make -f

# This file is part of the  X2Go Project - https://www.x2go.org
# Copyright (C) 2012-2019 by Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
#
# X2Go Session Broker is free software; you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# X2Go Session Broker is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program; if not, write to the
# Free Software Foundation, Inc.,
# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

SRC_DIR=$(CURDIR)
SHELL=/bin/bash

INSTALL_DIR=install -dm 755
INSTALL_FILE=install -m 644
INSTALL_PROGRAM=install -m 755
INSTALL_SYMLINK=ln -sf

CC               ?= gcc
override CFLAGS  += -fPIE
override LDFLAGS += -pie

RM_FILE=rm -f
RM_DIR=rmdir -p --ignore-fail-on-non-empty

GZIP = gzip -f --best

DESTDIR ?=
PREFIX ?= /usr/local
ETCDIR=/etc/x2go
BINDIR=$(PREFIX)/bin
SBINDIR=$(PREFIX)/sbin
LIBDIR  ?= $(PREFIX)/lib
DATADIR ?= $(PREFIX)/share
MANDIR=$(DATADIR)/man

X2GO_LIBDIR=$(LIBDIR)/x2go

BIN_SCRIPTS=$(shell cd bin && echo *)
SBIN_SCRIPTS=$(shell cd sbin && echo *)
LIB_FILES=$(shell cd lib && echo *)

PERL ?= /usr/bin/perl

SKIP_INSTALL_PYMODULE ?=

all: build

build: build-arch build-indep

build-arch: build_setuidwrappers build_pymodule

build_setuidwrappers:
	$(CC) $(CFLAGS) $(LDFLAGS) -DTRUSTED_BINARY=\"$(X2GO_LIBDIR)/x2gobroker-agent.pl\" -o lib/x2gobroker-agent src/x2gobroker-agent.c
	$(CC) $(CFLAGS) $(LDFLAGS) -DTRUSTED_BINARY=\"$(BINDIR)/x2gobroker\" -o bin/x2gobroker-ssh src/x2gobroker-ssh.c

build_pymodule:
	python3 setup.py build

build-indep:

distclean: clean

clean: clean_arch clean_indep

clean_arch:
	$(RM_FILE) lib/x2gobroker-agent
	$(RM_FILE) bin/x2gobroker-ssh

clean_indep:

check:
	python3 test.py

install:
	mkdir -p "${DESTDIR}/var/lib/x2gobroker" \
	        "${DESTDIR}/var/log/x2gobroker"

	# python3-x2gobroker
	[ -z "${SKIP_INSTALL_PYMODULE}" ] && python3 setup.py install --prefix="${PREFIX}" $${DESTDIR+--root="${DESTDIR}"} || :
	mkdir -p "${DESTDIR}${ETCDIR}/broker" "${DESTDIR}/etc/pam.d" \
	        "${DESTDIR}/etc/default"
	${INSTALL_FILE} defaults/python-x2gobroker.default \
	        "${DESTDIR}/etc/default/python-x2gobroker"
	${INSTALL_FILE} etc/x2gobroker.conf "${DESTDIR}${ETCDIR}/"
	${INSTALL_FILE} etc/broker/defaults.conf "${DESTDIR}${ETCDIR}/broker/"
	${INSTALL_FILE} etc/broker/x2gobroker-sessionprofiles.conf "${DESTDIR}${ETCDIR}/broker/"
	${INSTALL_FILE} etc/broker/x2gobroker-loggers.conf "${DESTDIR}${ETCDIR}/broker/"
	if [ -e /etc/debian_version ]; then ${INSTALL_FILE} pam/x2gobroker.Debian "${DESTDIR}/etc/pam.d/x2gobroker"; fi
	if [ -e /etc/redhat-release ]; then ${INSTALL_FILE} pam/x2gobroker.RHEL "${DESTDIR}/etc/pam.d/x2gobroker"; fi
	if [ -e /etc/os-release ] && cat /etc/os-release | grep "suse" 1>/dev/null || [ -d /usr/share/doc/packages/brp-check-suse ]; then ${INSTALL_FILE} pam/x2gobroker.SUSE "${DESTDIR}/etc/pam.d/x2gobroker"; fi

	# x2gobroker-agent
	mkdir -p "${DESTDIR}${X2GO_LIBDIR}" "${DESTDIR}${SBINDIR}" \
	        "${DESTDIR}${MANDIR}/man8"
	${INSTALL_FILE} man/man8/x2gobroker-pubkeyauthorizer.8* \
	        "${DESTDIR}${MANDIR}/man8"
	$(GZIP) "${DESTDIR}${MANDIR}/man8/"*.8
	${INSTALL_PROGRAM} lib/x2gobroker-agent* "${DESTDIR}${X2GO_LIBDIR}/"
	${INSTALL_PROGRAM} sbin/x2gobroker-pubkeyauthorizer "${DESTDIR}${SBINDIR}/"

	# x2gobroker-authservice
	mkdir -p "${DESTDIR}${SBINDIR}" "${DESTDIR}/etc/logrotate.d" \
	        "${DESTDIR}${ETCDIR}/broker" "${DESTDIR}/etc/default" \
	        "${DESTDIR}${MANDIR}/man8" "$(DESTDIR)$(LIBDIR)/tmpfiles.d/"
	${INSTALL_FILE} defaults/x2gobroker-authservice.default \
	        "${DESTDIR}/etc/default/x2gobroker-authservice"
	${INSTALL_FILE} man/man8/x2gobroker-authservice.8* \
	        "${DESTDIR}${MANDIR}/man8"
	$(GZIP) "${DESTDIR}${MANDIR}/man8/"*.8
	${INSTALL_PROGRAM} sbin/x2gobroker-authservice "${DESTDIR}${SBINDIR}/"
	${INSTALL_FILE} logrotate/x2gobroker-authservice \
	        "${DESTDIR}/etc/logrotate.d/"
	${INSTALL_FILE} etc/broker/x2gobroker-authservice-logger.conf \
	        "${DESTDIR}${ETCDIR}/broker/"
	${INSTALL_FILE} tmpfiles.d/x2gobroker-authservice.conf \
	        "${DESTDIR}${LIBDIR}/tmpfiles.d/"

	# x2gobroker-loadchecker
	mkdir -p "${DESTDIR}${SBINDIR}" "${DESTDIR}/etc/logrotate.d" \
	        "${DESTDIR}${ETCDIR}/broker" "${DESTDIR}/etc/default" \
	        "${DESTDIR}${MANDIR}/man8" "$(DESTDIR)$(LIBDIR)/tmpfiles.d/"
	${INSTALL_FILE} defaults/x2gobroker-loadchecker.default \
	        "${DESTDIR}/etc/default/x2gobroker-loadchecker"
	${INSTALL_FILE} man/man8/x2gobroker-loadchecker.8* \
	        "${DESTDIR}${MANDIR}/man8"
	$(GZIP) "${DESTDIR}${MANDIR}/man8/"*.8
	${INSTALL_PROGRAM} sbin/x2gobroker-loadchecker "${DESTDIR}${SBINDIR}/"
	${INSTALL_FILE} logrotate/x2gobroker-loadchecker \
	        "${DESTDIR}/etc/logrotate.d/"
	${INSTALL_FILE} etc/broker/x2gobroker-loadchecker-logger.conf \
	        "${DESTDIR}${ETCDIR}/broker/"
	${INSTALL_FILE} tmpfiles.d/x2gobroker-loadchecker.conf \
	        "${DESTDIR}${LIBDIR}/tmpfiles.d/"

	# x2gobroker-daemon
	mkdir -p "${DESTDIR}/etc/logrotate.d/" "${DESTDIR}/etc/default" \
	         "$(DESTDIR)$(LIBDIR)/tmpfiles.d/"
	${INSTALL_FILE} defaults/x2gobroker-daemon.default \
	        "${DESTDIR}/etc/default/x2gobroker-daemon"
	${INSTALL_FILE} logrotate/x2gobroker-daemon \
	        "${DESTDIR}/etc/logrotate.d/"
	mkdir -p "${DESTDIR}${BINDIR}" "${DESTDIR}${SBINDIR}" \
	        "${DESTDIR}${MANDIR}/man1" "${DESTDIR}${MANDIR}/man8"
	${INSTALL_FILE} man/man1/x2gobroker-daemon.1* \
	        "${DESTDIR}${MANDIR}/man1"
	$(GZIP) "${DESTDIR}${MANDIR}/man1/"*.1
	${INSTALL_FILE} man/man8/x2gobroker-daemon-debug.8* \
	        "${DESTDIR}${MANDIR}/man8"
	$(GZIP) "${DESTDIR}${MANDIR}/man8/"*.8
	${INSTALL_SYMLINK} x2gobroker \
	        "${DESTDIR}${BINDIR}/x2gobroker-daemon"
	${INSTALL_PROGRAM} sbin/x2gobroker-daemon-debug \
	        "${DESTDIR}${SBINDIR}/"
	${INSTALL_FILE} tmpfiles.d/x2gobroker-daemon.conf \
	        "${DESTDIR}${LIBDIR}/tmpfiles.d/"

	# x2gobroker-ssh
	mkdir -p "${DESTDIR}${BINDIR}" "${DESTDIR}${SBINDIR}" \
	         "${DESTDIR}${ETCDIR}/../sudoers.d" \
	         "${DESTDIR}${MANDIR}/man1"
	${INSTALL_FILE} man/man1/x2gobroker-ssh.1* \
	        "${DESTDIR}${MANDIR}/man1"
	${INSTALL_PROGRAM} bin/x2gobroker-ssh \
	        "${DESTDIR}${BINDIR}/"
	${INSTALL_FILE} x2gobroker-ssh.sudo \
	        "${DESTDIR}${ETCDIR}/../sudoers.d/"
	mv "${DESTDIR}${ETCDIR}/../sudoers.d/x2gobroker-ssh.sudo" "${DESTDIR}${ETCDIR}/../sudoers.d/x2gobroker-ssh"

	# x2gobroker-wsgi
	mkdir -p "${DESTDIR}${ETCDIR}" "${DESTDIR}/etc/logrotate.d"
	${INSTALL_FILE} etc/x2gobroker-wsgi.apache.{conf,vhost} \
	        "${DESTDIR}${ETCDIR}/"
	${INSTALL_FILE} logrotate/x2gobroker-wsgi "${DESTDIR}/etc/logrotate.d/"

	# x2gobroker
	mkdir -p "${DESTDIR}${BINDIR}" "${DESTDIR}${SBINDIR}" \
	        "${DESTDIR}${MANDIR}/man1"
	mkdir -p "${DESTDIR}${BINDIR}" "${DESTDIR}${SBINDIR}" \
	        "${DESTDIR}${MANDIR}/man8"
	${INSTALL_FILE} man/man1/x2gobroker{,-testauth}.1* \
	        "${DESTDIR}${MANDIR}/man1"
	$(GZIP) "${DESTDIR}${MANDIR}/man1/"*.1
	${INSTALL_FILE} man/man8/x2gobroker{-keygen,-testagent}.8* \
	        "${DESTDIR}${MANDIR}/man8"
	$(GZIP) "${DESTDIR}${MANDIR}/man8/"*.8
	${INSTALL_PROGRAM} bin/x2gobroker bin/x2gobroker-testauth \
	        "${DESTDIR}${BINDIR}/"
	${INSTALL_PROGRAM} sbin/x2gobroker-keygen sbin/x2gobroker-testagent \
	        "${DESTDIR}${SBINDIR}/"

=== debian/changelog ===
x2gobroker (0.0.4.0-3) unstable; urgency=medium

  * debian/patches:
    + Add 0001_sbin-x2gobroker-keygen-Fix-call-to-x2gobroker.utils..patch.
     Fix call to x2gobroker.utils.get_key_fingerprint_with_colons(). Thanks
     to Linnea Skogtvedt for spotting and reporting this.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 06 Feb 2019 19:41:33 +0100

x2gobroker (0.0.4.0-2) unstable; urgency=medium

  * debian/control:
    + Fix Vcs-*: fields. Copy+paste flaw (x2goclient -> x2gobroker).
  * debian/rules:
    + Only evoke doc cleanup, if Makefile.docupload is present. This fixes
      src:package builds in debian/-folder-only packaging repos.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 04 Feb 2019 08:55:02 +0100

x2gobroker (0.0.4.0-1) unstable; urgency=medium

  * Initial release to Debian. (Closes: #906073).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 02 Feb 2019 11:44:34 +0100

## x2gobroker 0.0.4.1

=== Makefile ===
--- 
+++ 
@@ -182,6 +182,9 @@
 	${INSTALL_FILE} etc/x2gobroker-wsgi.apache.{conf,vhost} \
 	        "${DESTDIR}${ETCDIR}/"
 	${INSTALL_FILE} logrotate/x2gobroker-wsgi "${DESTDIR}/etc/logrotate.d/"
+	mkdir -p "${DESTDIR}${LIBDIR}/x2gobroker/wsgi"
+	${INSTALL_SYMLINK} "${BINDIR}/x2gobroker" \
+	        "${DESTDIR}${LIBDIR}/x2gobroker/wsgi/x2gobroker-wsgi"
 
 	# x2gobroker
 	mkdir -p "${DESTDIR}${BINDIR}" "${DESTDIR}${SBINDIR}" \

=== debian/changelog ===
x2gobroker (0.0.4.1-1) unstable; urgency=medium

  * New upstream release (with specific fixes, targetting Debian buster).
    - Make builds reproducible. Thanks to Chris Lamb for providing a patch.
      (Closes: #922137).
    - Correctly initialize the loggers when using x2gobroker via WSGI in
      Apache2. (Closes: #922042).
    - x2gobroker-wsgi: Place WSGI script symlink (pointing to
      <BINDIR>/x2gobroker) into a dedicated folder and configure Apache2
      to use WSGIScriptAlias from that folder. (Closes: #922040).
    - Permit `asyncio` to create event loops on any thread (required on
      multithreaded WSGI servers using Python 3). (Closes: #925102).
    - Make remote agent's SSH HostKey policy configurable globally, backend-wise
      and per session profile. Fallback to RejectPolicy by default.
      (Closes: #922314).
    - x2gobroker/brokers/base_broker.py: Log IP address of authentication
      attempts. (Closes: #922458).
  * debian/patches:
    + Drop all patches. All changes applied upstream.
  * debian/changelog:
    + Fix indentation in previous changelog stanza.
  * debian/po:
    + Add French debconf translation. Thanks to Jean-Pierre Giraud. (Closes:
      #923381).
    + Add Dutch debconf translation. Thanks to Frans Spiesschaert. (Closes:
      #922774).
    + Add Portuguese debconf translation file. Thanks to Américo Monteiro.
      (Closes: #922527).
  * debian/x2gobroker-wsgi.install:
    + Add WSGIScriptAlias symlink path.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 23 Apr 2019 11:24:49 +0200

=== debian/control ===
Source: x2gobroker
Section: misc
Priority: optional
Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Mihai Moldovan <ionic@ionic.de>,
Build-Depends:
 debhelper (>= 10),
 dh-python,
 cdbs (>= 0.4.49~),
 dpkg-dev (>= 1.14.31~),
 python3 (>= 2.6.5-0~),
 python3-setuptools,
 python3-netaddr,
 python3-nose,
 python3-paramiko,
 python3-paste,
 python3-sphinx,
 python3-tornado,
Standards-Version: 4.3.0
Homepage: https://wiki.x2go.org/
Vcs-Git: https://salsa.debian.org/debian-remote-team/x2gobroker.git
Vcs-Browser: https://salsa.debian.org/debian-remote-team/x2gobroker/

Package: x2gobroker
Architecture: all
Depends:
 ${misc:Depends},
 python3,
 python3-setproctitle,
 python3-tornado,
 python3-wsgilog,
 python3-x2gobroker (>= ${source:Version}), python3-x2gobroker (<< ${source:Version}.1~),
Suggests:
 apache2 | httpd,
Description: X2Go Session Broker (executable)
 X2Go is a server based computing environment with
    - session resuming
    - low bandwidth support
    - session brokerage support
    - client side mass storage mounting support
    - client side printing support
    - audio support
    - authentication by smartcard and USB stick
 .
 The session broker is a server tool for X2Go that tells your X2Go Client
 application in a terminal server cluster what servers and session types are
 most appropriate for the user in front of the X2Go terminal.
 .
 A session broker is most useful in load balanced X2Go server farms.
 .
 This package contains the x2gobroker executable.

Package: x2gobroker-common
Architecture: all
Depends:
 ${misc:Depends},
Breaks:
 python-x2gobroker (<< 0.0.4.0~),
Replaces:
 python-x2gobroker (<< 0.0.4.0~),
Description: X2Go Session Broker (common files)
 X2Go is a server based computing environment with
    - session resuming
    - low bandwidth support
    - session brokerage support
    - client side mass storage mounting support
    - client side printing support
    - audio support
    - authentication by smartcard and USB stick
 .
 The session broker is a server tool for X2Go that tells your X2Go Client
 application in a terminal server cluster what servers and session types are
 most appropriate for the user in front of the X2Go terminal.
 .
 A session broker is most useful in load balanced X2Go server farms.
 .
 This package contains x2gobroker common files.

Package: python3-x2gobroker
Section: python
Architecture: all
Depends:
 ${misc:Depends},
 python3,
 python3-daemon,
 python3-lockfile,
 python3-pampy,
 python3-netaddr,
 python3-tornado,
 python3-paramiko,
 python3-urllib3,
 x2gobroker-common (>= ${source:Version}),
Recommends:
 python3-simplejson,
Breaks:
 python-x2gobroker (<< 0.0.4.0),
Replaces:
 python-x2gobroker (<< 0.0.4.0),
Description: X2Go Session Broker (Python3 modules)
 X2Go is a server based computing environment with
    - session resuming
    - low bandwidth support
    - session brokerage support
    - client side mass storage mounting support
    - client side printing support
    - audio support
    - authentication by smartcard and USB stick
 .
 The session broker is a server tool for X2Go that tells your X2Go Client
 application in a terminal server cluster what servers and session types are
 most appropriate for the user in front of the X2Go terminal.
 .
 A session broker is most useful in load balanced X2Go server farms.
 .
 This package contains common files needed by all X2Go session
 brokers being package for this distribution.


Package: python-x2gobroker-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
 libjs-jquery,
 libjs-underscore,
Description: X2Go Session Broker (Python3 module documentation)
 X2Go is a server based computing environment with
    - session resuming
    - low bandwidth support
    - session brokerage support
    - client side mass storage mounting support
    - client side printing support
    - audio support
    - authentication by smartcard and USB stick
 .
 The session broker is a server tool for X2Go that tells your X2Go Client
 application in a terminal server cluster what servers and session types are
 most appropriate for the user in front of the X2Go terminal.
 .
 A session broker is most useful in load balanced X2Go server farms.
 .
 This package contains the API documentation of the various X2Go Broker
 backends and shows how to extend the X2Go Session Broker.

Package: x2gobroker-authservice
Architecture: all
Depends:
 ${misc:Depends},
 adduser,
 lsb-base,
 python3,
 python3-setproctitle,
 python3-pampy,
 python3-x2gobroker (>= ${source:Version}), python3-x2gobroker (<< ${source:Version}.1~),
Suggests:
 x2gobroker-daemon,
Description: X2Go Session Broker (PAM authentication service)
 X2Go is a server based computing environment with
    - session resuming
    - low bandwidth support
    - session brokerage support
    - client side mass storage mounting support
    - client side printing support
    - audio support
    - authentication by smartcard and USB stick
 .
 The session broker is a server tool for X2Go that tells your X2Go Client
 application in a terminal server cluster what servers and session types are
 most appropriate for the user in front of the X2Go terminal.
 .
 A session broker is most useful in load balanced X2Go server farms.
 .
 This package contains the authentication service
 against the PAM system.

Package: x2gobroker-loadchecker
Architecture: all
Depends:
 ${misc:Depends},
 adduser,
 lsb-base,
 python3,
 python3-setproctitle,
 python3-x2gobroker (>= ${source:Version}), python3-x2gobroker (<< ${source:Version}.1~),
Suggests:
 x2gobroker-daemon,
Description: X2Go Session Broker (load checker service)
 X2Go is a server based computing environment with
    - session resuming
    - low bandwidth support
    - session brokerage support
    - client side mass storage mounting support
    - client side printing support
    - audio support
    - authentication by smartcard and USB stick
 .
 The session broker is a server tool for X2Go that tells your X2Go Client
 application in a terminal server cluster what servers and session types are
 most appropriate for the user in front of the X2Go terminal.
 .
 A session broker is most useful in load balanced X2Go server farms.
 .
 This package contains the load checker service required for broker setups
 with dynamic load balancing.

Package: x2gobroker-daemon
Architecture: all
Depends:
 ${misc:Depends},
 adduser,
 lsb-base,
 x2gobroker (>= ${source:Version}), x2gobroker (<< ${source:Version}.1~),
Recommends:
 x2gobroker-authservice,
Suggests:
 x2gobroker-loadchecker,
Description: X2Go Session Broker (standalone daemon)
 X2Go is a server based computing environment with
    - session resuming
    - low bandwidth support
    - session brokerage support
    - client side mass storage mounting support
    - client side printing support
    - audio support
    - authentication by smartcard and USB stick
 .
 The session broker is a server tool for X2Go that tells your X2Go Client
 application in a terminal server cluster what servers and session types are
 most appropriate for the user in front of the X2Go terminal.
 .
 A session broker is most useful in load balanced X2Go server farms.
 .
 This package contains the start-stop script that
 installs the X2Go Session Broker as standalone
 daemon.

Package: x2gobroker-wsgi
Architecture: all
Depends:
 ${misc:Depends},
 python3,
 adduser,
 x2gobroker (>= ${source:Version}), x2gobroker (<< ${source:Version}.1~),
Recommends:
 libapache2-mod-wsgi-py3,
Description: X2Go Session Broker (WSGI)
 X2Go is a server based computing environment with
    - session resuming
    - low bandwidth support
    - session brokerage support
    - client side mass storage mounting support
    - client side printing support
    - audio support
    - authentication by smartcard and USB stick
 .
 The session broker is a server tool for X2Go that tells your X2Go Client
 application in a terminal server cluster what servers and session types are
 most appropriate for the user in front of the X2Go terminal.
 .
 A session broker is most useful in load balanced X2Go server farms.
 .
 This package contains an Apache2 configuration that
 installs the X2Go Session Broker as a WSGI application
 into a running Apache2 httpd.

Package: x2gobroker-agent
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 python3,
 python3-setproctitle,
 python3-paramiko,
 perl,
 adduser,
 libfile-which-perl,
Suggests:
 x2goserver (>= 4.0.1.16-0~),
Description: X2Go Session Broker (remote agent)
 X2Go is a server based computing environment with
    - session resuming
    - low bandwidth support
    - session brokerage support
    - client side mass storage mounting support
    - client side printing support
    - audio support
    - authentication by smartcard and USB stick
 .
 The session broker is a server tool for X2Go that tells your X2Go Client
 application in a terminal server cluster what servers and session types are
 most appropriate for the user in front of the X2Go terminal.
 .
 A session broker is most useful in load balanced X2Go server farms.
 .
 This package contains a setuid agent command that extends X2Go Session Broker
 functionality. It has to be installed on X2Go Servers that shall be
 controlled via a session broker.
 .
 The broker agent provides means to the X2Go Session Broker for controlling
 the X2Go Server it is installed on (e.g. suspend/terminate sessions, deploy
 SSH login keys, detect server load, detect running/suspended sessions
 of connecting users, etc.).
 .
 WARNING: This package installs a setuid wrapper
 (/usr/lib/x2go/broker/x2gobroker-agent) on your system. This setuid wrapper
 aims to be a secure replacement for the deprecated suidperl executable that
 was removed from Perl (>= 5.12).
 .
 This wrapper is only able to execute the Perl script
 /usr/lib/x2go/broker/x2gobroker-agent.pl. For running properly,
 x2gobroker-agent.pl needs setuid root privileges.
 .
 If you hesitate to install this package, study the code of the named wrapper
 and the named Perl script beforehand. Note that the X2Go session broker will
 lack functionality, but it will work without this x2gobroker-agent component
 installed on your to-be-managed X2Go servers.

Package: x2gobroker-ssh
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 adduser,
 x2gobroker (>= ${source:Version}), x2gobroker (<< ${source:Version}.1~),
Description: X2Go Session Broker (SSH broker)
 X2Go is a server based computing environment with
    - session resuming
    - low bandwidth support
    - session brokerage support
    - client side mass storage mounting support
    - client side printing support
    - audio support
    - authentication by smartcard and USB stick
 .
 The session broker is a server tool for X2Go that tells your X2Go Client
 application in a terminal server cluster what servers and session types are
 most appropriate for the user in front of the X2Go terminal.
 .
 A session broker is most useful in load balanced X2Go server farms.
 .
 This add-on package provides fully-featured SSH brokerage
 support (with access to broker agents on remote X2Go
 Servers).

=== debian/rules ===
#!/usr/bin/make -f

# Copyright (C) 2012-2018 by Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program; if not, write to the
# Free Software Foundation, Inc.,
# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

# this doesn't work, so commenting it out...
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND = -Wall
#include /usr/share/dpkg/buildflags.mk

export PREFIX=/usr
export DESTDIR="$(DEB_DESTDIR)"
export SKIP_INSTALL_PYMODULE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/rules/utils.mk

# disable unit tests (for now), they don't (yet) work with offline builds
#DEB_MAKE_CHECK_TARGET = check
DEB_MAKE_INSTALL_TARGET = install

DEB_PYTHON_SYSTEM = $(shell test -f /usr/bin/dh_python3 && echo "" || echo "pysupport")

include /usr/share/cdbs/1/class/python-distutils.mk

configure/python-x2gobroker-doc::
	if [ ! -f docs/build/html/index.html ]; then \
		make -f Makefile.docupload docbuild; \
	fi

# somehow, the symlinks do not make it into the upstream tarball...
post-patches::
	ln -fs x2gobroker.1 man/man1/x2gobroker-daemon.1
	ln -fs x2gobroker.1 man/man1/x2gobroker-ssh.1

common-binary-indep::
	cp pam/x2gobroker.Debian pam/x2gobroker
	cp x2gobroker-ssh.sudo x2gobroker-ssh

common-binary-arch:: common-binary-indep
common-binary-post-install-arch:: list-missing

clean::
	if [ -e Makefile.docupload ]; then make -f Makefile.docupload clean; fi
	rm -f pam/x2gobroker
	rm -f lib/x2gobroker-agent
	rm -f x2gobroker-ssh
	rm -f man/man1/x2gobroker-daemon.1
	rm -f man/man1/x2gobroker-ssh.1
	rm -Rf x2gobroker.egg-info/

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## x2gobroker 0.0.4.3

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 # This file is part of the  X2Go Project - https://www.x2go.org
-# Copyright (C) 2012-2019 by Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
+# Copyright (C) 2012-2020 by Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
 #
 # X2Go Session Broker is free software; you can redistribute it and/or modify
 # it under the terms of the GNU Affero General Public License as published by

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# required in the Python X2Go Broker code... e.g. in x2gobroker/defaults.py
SPHINX_API_DOCUMENTATION_BUILD = yes

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  epub3      to make an epub3"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"
	@echo "  dummy      to check syntax errors of document sources"

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*

.PHONY: html
html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: dirhtml
dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

.PHONY: singlehtml
singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

.PHONY: pickle
pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

.PHONY: json
json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

.PHONY: htmlhelp
htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

.PHONY: qthelp
qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/X2GoSessionBroker.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/X2GoSessionBroker.qhc"

.PHONY: applehelp
applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

.PHONY: devhelp
devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/X2GoSessionBroker"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/X2GoSessionBroker"
	@echo "# devhelp"

.PHONY: epub
epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

.PHONY: epub3
epub3:
	$(SPHINXBUILD) -b epub3 $(ALLSPHINXOPTS) $(BUILDDIR)/epub3
	@echo
	@echo "Build finished. The epub3 file is in $(BUILDDIR)/epub3."

.PHONY: latex
latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

.PHONY: latexpdf
latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: latexpdfja
latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: text
text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

.PHONY: man
man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

.PHONY: texinfo
texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

.PHONY: info
info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

.PHONY: gettext
gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

.PHONY: changes
changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

.PHONY: linkcheck
linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

.PHONY: doctest
doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

.PHONY: coverage
coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

.PHONY: xml
xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

.PHONY: pseudoxml
pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

.PHONY: dummy
dummy:
	$(SPHINXBUILD) -b dummy $(ALLSPHINXOPTS) $(BUILDDIR)/dummy
	@echo
	@echo "Build finished. Dummy builder generates no files."

=== debian/changelog ===
x2gobroker (0.0.4.3-4.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop CDBS from build (Closes: #1111783)

 -- Alexandre Detiste <tchet@debian.org>  Sun, 31 Aug 2025 11:52:06 +0200

x2gobroker (0.0.4.3-4.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove Depends: python3-wsgilog. (Closes: #1087443)

 -- Bastian Germann <bage@debian.org>  Thu, 24 Apr 2025 13:07:31 +0200

x2gobroker (0.0.4.3-4.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Replace Nose with Pytest (Close: #1018666)
  * Add dependency on python3-pyasyncore (Closes: #1082881)
  * Add dependency on python3-six (Closes: #1082884)
  * Add a runtime dependency on python3-setuptools (Closes: #1082883)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 19 Feb 2025 12:45:09 +0100

x2gobroker (0.0.4.3-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No source change upload to move systemd units into /usr.

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 25 May 2024 09:56:26 +0200

x2gobroker (0.0.4.3-4) unstable; urgency=medium

  * debian/*.postrm:
    + De-duplicate delgroup calls. Thanks to Patrice Duroux for highlighting
      this. (Releates to #1035847).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 19 May 2023 10:54:13 +0200

x2gobroker (0.0.4.3-3) unstable; urgency=medium

  [ Johannes Schauer Marin Rodrigues ]
  * debian/*.postrm:
    + Ignore failures when evoking (possibly not installed) deluser. (Closes:
      #1035847).

  [ Mike Gabriel ]
  * debian/po:
    + Add Spanish debconf translation. Thanks to Camaleón. (Closes: #987522).
    + Add Brazilian Portuguese debconf translation. Thanks to Paulo Henrique de
      Lima Santana. (Closes: #1026413).
  * debian/control:
    + Drop from D: lsb-base (obsoleted package). Thanks, lintian.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 16 May 2023 21:27:13 +0200

x2gobroker (0.0.4.3-2) unstable; urgency=medium

  * debian/control:
    + Bump Standards-Version: to 4.6.0. No changes needed.
  * debian/patches:
    + Add 2001_no_2to3_supported_any_more.patch. Don't run setup.py with
      use_2to3 anymore. Support for it has been dropped. (Closes: #997604).
    + Forward patches 1003 and 2001.
    + Add 0001_man-man1-x2gobroker.1-Fix-apostrophe-usage-drop-prec.patch.
      Thanks, lintian.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 15 Nov 2021 15:17:01 +0100

x2gobroker (0.0.4.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Add Rules-Requires-Root: field and set it to no.
    + Bump Standards-Version: to 4.5.0. No changes needed.
    + Add D (x2gobroker-ssh): procps.
  * debian/patches:
    + Add 1003_handle-offline-builds.patch. Enable offline builds.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/x2gobroker-ssh.postinst:
    + Only invalidate nscd group cache if nscd is running / in use. (See X2Go
      upstream bug #1458).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 16 Nov 2020 10:30:52 +0100

=== debian/control ===
--- 
+++ 
@@ -6,19 +6,19 @@
  Mike Gabriel <sunweaver@debian.org>,
  Mihai Moldovan <ionic@ionic.de>,
 Build-Depends:
- debhelper (>= 10),
- dh-python,
- cdbs (>= 0.4.49~),
- dpkg-dev (>= 1.14.31~),
- python3 (>= 2.6.5-0~),
+ debhelper-compat (= 13),
+ dh-sequence-python3,
+ python3,
+ python3-pyasyncore,
  python3-setuptools,
  python3-netaddr,
- python3-nose,
  python3-paramiko,
  python3-paste,
+ python3-pytest <!nocheck>,
+ python3-six,
  python3-sphinx,
  python3-tornado,
-Standards-Version: 4.3.0
+Standards-Version: 4.7.2
 Homepage: https://wiki.x2go.org/
 Vcs-Git: https://salsa.debian.org/debian-remote-team/x2gobroker.git
 Vcs-Browser: https://salsa.debian.org/debian-remote-team/x2gobroker/
@@ -28,9 +28,11 @@
 Depends:
  ${misc:Depends},
  python3,
+ python3-pyasyncore,
  python3-setproctitle,
+ python3-setuptools,
+ python3-six,
  python3-tornado,
- python3-wsgilog,
  python3-x2gobroker (>= ${source:Version}), python3-x2gobroker (<< ${source:Version}.1~),
 Suggests:
  apache2 | httpd,
@@ -54,6 +56,7 @@
 
 Package: x2gobroker-common
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends},
 Breaks:
@@ -121,6 +124,7 @@
 Package: python-x2gobroker-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends},
  libjs-jquery,
@@ -149,7 +153,6 @@
 Depends:
  ${misc:Depends},
  adduser,
- lsb-base,
  python3,
  python3-setproctitle,
  python3-pampy,
@@ -180,7 +183,6 @@
 Depends:
  ${misc:Depends},
  adduser,
- lsb-base,
  python3,
  python3-setproctitle,
  python3-x2gobroker (>= ${source:Version}), python3-x2gobroker (<< ${source:Version}.1~),
@@ -210,7 +212,6 @@
 Depends:
  ${misc:Depends},
  adduser,
- lsb-base,
  x2gobroker (>= ${source:Version}), x2gobroker (<< ${source:Version}.1~),
 Recommends:
  x2gobroker-authservice,
@@ -323,6 +324,7 @@
  ${shlibs:Depends},
  ${misc:Depends},
  adduser,
+ procps,
  x2gobroker (>= ${source:Version}), x2gobroker (<< ${source:Version}.1~),
 Description: X2Go Session Broker (SSH broker)
  X2Go is a server based computing environment with

=== debian/rules ===
#!/usr/bin/make -f

# Copyright (C) 2012-2018 by Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program; if not, write to the
# Free Software Foundation, Inc.,
# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

export PREFIX=/usr
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

%:
	dh $@ --buildsystemd=pybuild

# somehow, the symlinks do not make it into the upstream tarball...
execute_before_dh_auto_build:
	ln -fs x2gobroker.1 man/man1/x2gobroker-daemon.1
	ln -fs x2gobroker.1 man/man1/x2gobroker-ssh.1

execute_after_dh_auto_build:
	make -f Makefile.docupload docbuild

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://code.x2go.org/releases/source/x2gobroker/x2gobroker-(\d+\.\d+\.\d+\.\d+)\.tar\.gz
